<?php
if (ereg('./amm_output.php$', $_SERVER['PHP_SELF'])) die('Access denied.'); // direct access protection

/**
 * getMedia interprets the Constants passed in, and executes the resulting DB query,
 * passing an associative array through to $template();
 *
 * @param string $template
 * @param int $items
 * @param CONST $groups
 * @param CONST $sort
 * @param CONST $rating
 * @return boolean , true if output is successful, false otherwise
 */
function amm_getMedia($template='amm_default_output',$items=1, $groups=AMM_ALL, $sort=AMM_DATE_DESC, $rating=AMM_RATING_ALL){
	global $wpdb;
	global $table_prefix;
	global $sz_deffunc;

	// Set limit
	$limit = $items > 0 ? 'LIMIT ' . $items : '';

	// set the ratings pulled
	switch($rating){
		case AMM_RATING_5:
		$rating = 'AND amm_rating = 5';
		break;
		case AMM_RATING_4:
		$rating = 'AND amm_rating = 4';
		break;
		case AMM_RATING_3:
		$rating = 'AND amm_rating = 3';
		break;
		case AMM_RATING_2:
		$rating = 'AND amm_rating = 2';
		break;
		case AMM_RATING_1:
		$rating = 'AND amm_rating = 1';
		break;
		case AMM_RATING_0:
		$rating = 'AND amm_rating = 0';
		break;
		case AMM_RATING_4UP:
		$rating = 'AND amm_rating >= 4';
		break;
		case AMM_RATING_3UP:
		$rating = 'AND amm_rating >= 3';
		break;
		case AMM_RATING_2UP:
		$rating = 'AND amm_rating >= 2';
		break;
		case AMM_RATING_1UP:
		$rating = 'AND amm_rating >= 1';
		break;
		case AMM_RATING_4DOWN:
		$rating = 'AND amm_rating <= 4';
		break;
		case AMM_RATING_3DOWN:
		$rating = 'AND amm_rating <= 3';
		break;
		case AMM_RATING_2DOWN:
		$rating = 'AND amm_rating <= 2';
		break;
		case AMM_RATING_1DOWN:
		$rating = 'AND amm_rating <= 1';
		break;
		case AMM_RATING_ALL:
		default:
		$rating = '';
	}

	// Do the groups
	$where = array();
	if ($groups & AMM_APPAREL) 	$where[] = "'Apparel'";
	if ($groups & AMM_BOOKS) 		$where[] = "'Book'";
	if ($groups & AMM_BABY) 		$where[] = "'Baby OR Baby Product'";
	if ($groups & AMM_BEAUTY) 	$where[] = "'Beauty' OR 'Health and Beauty'";
	if ($groups & AMM_ELEC) 		$where[] = "'CE'";
	if ($groups & AMM_GOURMET) 	$where[] = "'Gourmet' OR 'Restaurants'";
	if ($groups & AMM_TOOLS) 		$where[] = "'Home Improvement'";
	if ($groups & AMM_JEWELERY) $where[] = "'Jewelry'";
	if ($groups & AMM_KITCHEN) 	$where[] = "'Kitchen'";
	if ($groups & AMM_PATIO) 		$where[] = "'Lawn  Patio'";
	if ($groups & AMM_INSTRUMENTS) $where[] = "'Musical Instruments'";
	if ($groups & AMM_OFFICE) 	$where[] = "'Office Product'";
	if ($groups & AMM_PC) 			$where[] = "'Personal Computer'";
	if ($groups & AMM_PHOTO) 		$where[] = "'Photography'";
	if ($groups & AMM_MISC) 		$where[] = "'Single Detail Page Misc'";
	if ($groups & AMM_SOFTWARE) $where[] = "'Software'";
	if ($groups & AMM_SPORTS) 	$where[] = "'Sports'";
	if ($groups & AMM_TOYS) 		$where[] = "'Toys'";
	if ($groups & AMM_WIRELESS) $where[] = "'Wireless'";
	if ($groups & AMM_PHONE) 		$where[] = "'Wireless Phone Accessory'";
	if ($groups & AMM_WATCH) 		$where[] = "'Watch'";
	if ($groups & AMM_GAMES) 		$where[] = "'Video Games'";
	if ($groups & AMM_MAGAZINE) $where[] = "'Magazine'";
	if ($groups & AMM_VIDEO) 		$where[] = "'Video'";
	if ($groups & AMM_DVD) 			$where[] = "'DVD'";
	if ($groups & AMM_MUSIC) 		$where[] = "'Music'";
	// Explode the array with 'OR amm_productGroup=' between elements.
	$where = 'WHERE (amm_productGroup=' . implode(' OR amm_productGroup=',$where) . ')';

	// Set sort order
	switch($sort){
		case AMM_DATE_ASC:
		$order = 'ORDER BY amm_dateadded ASC';
		break;

		case AMM_RATING_ASC:
		$order = 'ORDER BY amm_rating ASC';
		break;

		case AMM_RATING_DESC:
		$order = 'ORDER BY amm_rating DESC';
		break;

		case AMM_RANDOM:
		$order = 'ORDER BY RAND()';
		break;

		case AMM_DATE_DESC:
		default:
		$order = 'ORDER BY amm_dateadded DESC';
		break;
	}
	$amm_sql = 'SELECT * FROM '. $table_prefix .AMM_TABLE.' '. $where .' '. $rating .' '. $order .' '. $limit;
	$wpdb->hide_errors();
	$amm_sqlResult = $wpdb->get_results($amm_sql, ARRAY_A);
	if ($amm_sqlResult == 0){
		echo '<!-- Nothing to display from AMM -->';
		return false;
	}
	if ($amm_sqlResult === FALSE){
		echo '<!-- SQL or Database error! -->';
		echo "<!-- $wpdb->print_error() -->";
		return false;
	}
	// Call the specific template function
	$amm_sqlResult = new amm_Output($amm_sqlResult);

	if (function_exists($template) && in_array($template, $sz_deffunc)){
		$template($amm_sqlResult);
	}else{
		// error gracefully.
		echo '<strong>' . __("Template $template could not be found. View HTML source for details.",AMM_DOM) . '</strong>' ;
		_e("<!--Template $template could not be found. Check that the template you have put in your amm_getMedia() function exists in amm_extras.php and is spelt correctly.-->",AMM_DOM);
	}
	return true;
}


function amm_getMediaID($template='amm_default_output',$id=1){
	global $wpdb;
	global $table_prefix;
	global $sz_deffunc;
	
	// Take a media ID, use that to get 1 row, put in assoc array, pass through to callback func.
	$amm_sql = 'SELECT * FROM '. $table_prefix .AMM_TABLE.' WHERE amm_itemId='.$id.';';
	$wpdb->hide_errors();
	$amm_sqlResult = $wpdb->get_results($amm_sql, ARRAY_A);
	if ($amm_sqlResult == 0){
		echo '<!-- Nothing to display from AMM -->';
		echo '<span class="amm_err">'.__('No items Found',AMM_DOM).'</span>';
		return false;
	}
	if ($amm_sqlResult === FALSE){
		echo '<!-- SQL or Database error! -->';
		echo "<!-- $wpdb->print_error() -->";
		echo '<span class="amm_err">'.__('AMM has encountered a problem. View the page source in your browser for more details.',AMM_DOM).'</span>';
		return false;
	}
	// Call the specific template function
	$amm_sqlResult = new amm_Output($amm_sqlResult);

	if (function_exists($template) && in_array($template, $sz_deffunc)){
		$template($amm_sqlResult);
	}else{
		// error gracefully.
		echo '<strong>' . __("Template $template could not be found. View HTML source for details.",AMM_DOM) . '</strong>' ;
		_e("<!--Template $template could not be found. Check that the template you have put in your amm_getMedia() function exists in amm_extras.php and is spelt correctly.-->",AMM_DOM);
	}
	return true;
}

/*
function getMediaQuery($template='amm_default_output',$query=''){
// Take a query, run it, pass the results as an assoc array to the callback.
}
*/

/**
 * amm_Output - contains the necessary wrapper and accessor functions to allow the
 * end user to easily customise their template output
 */
class amm_Output{

	/**
	 * Result array passed in from a Getmedia query.
	 *
	 * @var array
	 */
	var $results;

	/**
	 * Array holding the currently selected record
	 * @var array (amm_author, amm_director, amm_title, amm_asin, amm_productGroup,
	 							 amm_publisher, amm_artist, amm_label, amm_manufacturer, amm_model,
	 							 amm_brand,	amm_imageAddress, amm_userComments, amm_rating, amm_country, amm_smallImageURL)
	 */
	var $currentItem;

	/**
	 * Number of items in the result array
	 * @var int
	 */
	var $itemCount;

	/**
	 * Internal index for the results array. Default 0. Leave it that way.
	 * @var int
	 */
	var $index;

	var $affiliate;

	var $msg; // Debug message string

	function amm_Output($results){

		$this->index = 0;
		$this->msg = '';
		$this->results = $results;
		if (!is_array($this->results)){
			$this->msg='Function parameter was not an array, returning false';
			return false; // We don't have a valid result array
		}
		$this->itemCount = sizeof($this->results);
		if ($this->itemCount < 1) {
			$this->msg='Results array was empty, returning false';
			return false; // We don't have a valid result array
		}
		$this->affiliate = get_option('amm_associd');
		if ( !$this->affiliate ) update_option('amm_associd', AMM_AFFILIATE);

		$this->currentItem = $this->results[$this->index];
		return true;
	}

	function resetIndex(){
		$this->index = 0;
		$this->currentItem = $this->results[$this->index];
		$this->msg = 'Index reset to 0';
	}

	function nextItem(){
		if ( $this->index < $this->itemCount ) {
			$this->index++;
			$this->currentItem = $this->results[$this->index];
			$this->msg = 'currentItem set to record '.$this->index;
			return true;
		}else{
			$this->msg = 'End of index reached';
			return false;
		}
	}

	function prevItem(){
		if ( $this->index > $this->itemCount ) {
			$this->index--;
			return true;
		}else{
			$this->msg = 'Start of index reached';
			return false;
		}
	}

	/*****************  Accessor function for item data  ***********************/

	function id(){
		return $this->currentItem['amm_itemId'];
	}
	function author(){
		return stripslashes($this->currentItem['amm_author']);
	}
	function director(){
		return stripslashes($this->currentItem['amm_director']);
	}
	function title(){
		return stripslashes($this->currentItem['amm_title']);
	}
	function asin(){
		return stripslashes($this->currentItem['amm_asin']);
	}
	function productGroup(){
		return stripslashes($this->currentItem['amm_productGroup']);
	}
	function publisher(){
		return stripslashes($this->currentItem['amm_publisher']);
	}
	function artist(){
		return stripslashes($this->currentItem['amm_artist']);
	}
	function label(){
		return stripslashes($this->currentItem['amm_label']);
	}
	function manufacturer(){
		return stripslashes($this->currentItem['amm_manufacturer']);
	}
	function model(){
		return stripslashes($this->currentItem['amm_model']);
	}
	function brand(){
		return stripslashes($this->currentItem['amm_brand']);
	}
	function userComments(){
		return stripslashes($this->currentItem['amm_userComments']);
	}
	function rating(){
		return $this->currentItem['amm_rating'];
	}
	function country(){
		return $this->currentItem['amm_country'];
	}
	function date($format='Y-m-d H:i:s'){
		return date($format,strtotime($this->currentItem['amm_dateadded']));
	}
	function storedImage(){
		return $this->currentItem['amm_smallImageURL'];
	}

	function totalItems(){
		return $this->itemCount;
	}
	/**
	 * Automatically generates an amazon affiliate link for the country the
	 * item was sourced from. For now it will use the constant AMM_AFFILIATE
	 * which can be modified by the end user as desired.
	 */
	function URL(){
		//http://www.amazon.com/exec/obidos/ASIN/1560976144/denyersphotog-21/
		switch($this->currentItem['amm_country']){
			case 'uk':
			$ext = '.co.uk';
			break;
			case 'ca':
			$ext = '.ca';
			break;
			case 'fr':
			$ext = '.fr';
			break;
			case 'de':
			$ext = '.de';
			break;
			case 'jp':
			$ext = '.co.jp';
			break;
			case 'us':
			default:
			$ext = '.com';
			break;
		}
		return 'http://www.amazon' . $ext . '/exec/obidos/ASIN/' . $this->currentItem['amm_asin'] . '/' . $this->affiliate . '/';
	}

	/**
	 * Fancy Ratings - This will return the HTML for an image, 0.gif through 5.gif
	 * 								These images are stored in the wp-content/plugins/amm folder
	 *									so you can change them if you wish.
	 */

	function fancyRatings(){
		switch ($this->currentItem['amm_rating']){
			case '5':
			return '<img src="'.get_settings('home').'/wp-content/plugins/amm/5.gif" alt="'.__('Rating',AMM_DOM).': '.$this->currentItem['amm_rating'].'"/>';
			break;
			case '4':
			return '<img src="'.get_settings('home').'/wp-content/plugins/amm/4.gif" alt="'.__('Rating',AMM_DOM).': '.$this->currentItem['amm_rating'].'"/>';
			break;
			case '3':
			return '<img src="'.get_settings('home').'/wp-content/plugins/amm/3.gif" alt="'.__('Rating',AMM_DOM).': '.$this->currentItem['amm_rating'].'"/>';
			break;
			case '2':
			return '<img src="'.get_settings('home').'/wp-content/plugins/amm/2.gif" alt="'.__('Rating',AMM_DOM).': '.$this->currentItem['amm_rating'].'"/>';
			break;
			case '1':
			return '<img src="'.get_settings('home').'/wp-content/plugins/amm/1.gif" alt="'.__('Rating',AMM_DOM).': '.$this->currentItem['amm_rating'].'"/>';
			break;
			case '0':
			default:
			return '<img src="'.get_settings('home').'/wp-content/plugins/amm/0.gif" alt="'.__('Rating',AMM_DOM).': '.$this->currentItem['amm_rating'].'"/>';
			break;
		}
	}

	/**
	 * Returns a clickable image link to the item, for convenience as this is a common request
	 * @param variant $size
	 * @return string
	 */
	function imageLink($size='small'){
		$imagelink = '<a href="'. $this->URL() .'" title="'. __('Click to view item at Amazon') .'"><img src="'. $this->autoImage($size) .'" alt="'. $this->currentItem['amm_title'] .'" /></a>';
		return $imagelink;
	}

	/**
	 * Will attempt to map the most relevant field of any item to an 'author'
	 * EG for electronics, when requesting autoAuthor you should get Manufacturer returned.
	 * This is to allow a simpler template for generic output to be used.
	 */
	function autoAuthor(){
		//	 (amm_author, amm_director, amm_title, amm_asin, amm_productGroup,
		//		amm_publisher, amm_artist, amm_label, amm_manufacturer, amm_model,
		// 		amm_brand,	amm_imageAddress, amm_userComments, amm_rating, amm_country)
		// Use $this->currentItem['amm_productGroup']
		// switch on this and return the best 'mapped' value for Author
		switch (strtolower($this->currentItem['amm_productGroup'])){
			// 30 categories
			case 'apparel':	return $this->currentItem['amm_brand'];					break;
			case 'book':		return $this->currentItem['amm_author'];				break;

			case 'automotive parts and accessories':
			case 'baby':
			case 'baby product':
			case 'beauty':
			case 'ce':
			case 'gourmet':
			case 'health and beauty':
			case 'home improvement':
			case 'jewelery':
			case 'kitchen':
			case 'lawn  patio':
			case 'musical instruments':
			case 'office product':
			case 'personal computer':
			case 'photography':
			case 'single detail page misc':
			case 'software':
			case 'sports':
			case 'toys':
			case 'wireless':
			case 'wireless phone accessory':
			case 'watch':		return $this->currentItem['amm_manufacturer'];	break;

			case 'video games':
			case 'magazine':return $this->currentItem['amm_publisher'];			break;

			case 'video':
			case 'dvd':			return $this->currentItem['amm_director'];			break;

			case 'downloadable music':
			case 'music':
			if ($this->currentItem['amm_artist'] == ''){
				return $this->currentItem['amm_label'];
			}else{
				return $this->currentItem['amm_artist'];
			}
			break;

			default:				return $this->currentItem['amm_author'];				break;
		}
	}

	/**
	 * Will attempt to map the most relevant label of any item to an 'author'
	 * EG for electronics, when requesting autoAuthor you should get 'Manufacturer' returned.
	 * This allows you to
	 */
	function autoAuthorLabel(){
		switch (strtolower($this->currentItem['amm_productGroup'])){
			// 30 categories
			case 'apparel':	return __('Brand',AMM_DOM);							break;
			case 'book':		return __('Author',AMM_DOM);				break;

			case 'automotive parts and accessories':
			case 'baby':
			case 'baby product':
			case 'beauty':
			case 'ce':
			case 'gourmet':
			case 'health and beauty':
			case 'home improvement':
			case 'jewelery':
			case 'kitchen':
			case 'lawn  patio':
			case 'musical instruments':
			case 'office product':
			case 'personal computer':
			case 'photography':
			case 'single detail page misc':
			case 'software':
			case 'sports':
			case 'toys':
			case 'wireless':
			case 'wireless phone accessory':
			case 'watch':		return __('Manufacturer',AMM_DOM);	break;

			case 'video games':
			case 'magazine':return __('Publisher',AMM_DOM);			break;

			case 'video':
			case 'dvd':			return __('Director',AMM_DOM);			break;

			case 'downloadable music':
			case 'music': 	return __('Artist',AMM_DOM);				break;

			default:				return __('Author',AMM_DOM);				break;
		}
	}

	/**
	 * Returns the URL for an amazon image, autogenerated from the current item ASIN
	 * Parameter can be desired output size as Integer, or 'small', 'medium' or 'large'
	 * @param variant $size
	 * @return string
	 */

	function autoImage($size='small'){
		if (is_integer($size)){
			switch($this->currentItem['amm_country']){
				case 'jp':
				$image = 'http://images-jp.amazon.com/images/P/' . $this->currentItem['amm_asin'] . '.09._AA' . $size . '_.jpg';
				break;

				case 'uk':
				case 'fr':
				$image = 'http://images-eu.amazon.com/images/P/' . $this->currentItem['amm_asin'] . '.02._AA' . $size . '_.jpg';
				break;
				case 'de':
				$image = 'http://images-eu.amazon.com/images/P/' . $this->currentItem['amm_asin'] . '.03._AA' . $size . '_.jpg';
				break;

				case 'ca':
				case 'us':
				default:
				$image = 'http://images.amazon.com/images/P/' . $this->currentItem['amm_asin'] . '.01._AA' . $size . '_.jpg';
				break;
			}
		}else{
			switch($this->currentItem['amm_country']){
				case 'jp':
				switch($size){
					case 'large':
					$image = 'http://images-jp.amazon.com/images/P/' . $this->currentItem['amm_asin'] . '.09._PE_SCMZZZZZZZ_.jpg';
					break;
					case 'medium':
					$image = 'http://images-jp.amazon.com/images/P/' . $this->currentItem['amm_asin'] . '.09.TZZZZZZZ.jpg';
					break;
					case 'small':
					default:
					$image = 'http://images-jp.amazon.com/images/P/' . $this->currentItem['amm_asin'] . '.09.THUMBZZZ.jpg';
					break;
				}
				break;

				case 'uk':
				case 'fr':
				switch($size){
					case 'large':
					$image = 'http://images-eu.amazon.com/images/P/' . $this->currentItem['amm_asin'] . '.02._PE_SCMZZZZZZZ_.jpg';
					break;
					case 'medium':
					$image = 'http://images-eu.amazon.com/images/P/' . $this->currentItem['amm_asin'] . '.02.TZZZZZZZ.jpg';
					break;
					case 'small':
					default:
					$image = 'http://images-eu.amazon.com/images/P/' . $this->currentItem['amm_asin'] . '.02.THUMBZZZ.jpg';
					break;
				}
				break;
				case 'de':
				switch($size){
					case 'large':
					$image = 'http://images-eu.amazon.com/images/P/' . $this->currentItem['amm_asin'] . '.03._PE_SCMZZZZZZZ_.jpg';
					break;
					case 'medium':
					$image = 'http://images-eu.amazon.com/images/P/' . $this->currentItem['amm_asin'] . '.03.TZZZZZZZ.jpg';
					break;
					case 'small':
					default:
					$image = 'http://images-eu.amazon.com/images/P/' . $this->currentItem['amm_asin'] . '.03.THUMBZZZ.jpg';
					break;
				}
				break;

				case 'ca':
				case 'us':
				default:
				switch($size){
					case 'large':
					$image = 'http://images.amazon.com/images/P/' . $this->currentItem['amm_asin'] . '.02._PE_SCMZZZZZZZ_.jpg';
					break;
					case 'medium':
					$image = 'http://images.amazon.com/images/P/' . $this->currentItem['amm_asin'] . '.01.TZZZZZZZ.jpg';
					break;
					case 'small':
					default:
					$image = 'http://images.amazon.com/images/P/' . $this->currentItem['amm_asin'] . '.01.THUMBZZZ.jpg';
					break;
				}
				break;
			}
		}

		if (ini_get('safe_mode') != 1){
			$imageinfo = @getimagesize($image);
			if ( $imageinfo === FALSE ) $image = $this->currentItem['amm_smallImageURL'];
		}

		if ( '' == $image ) $image='http://g-images.amazon.com/images/G/01/x-site/icons/no-img-sm.gif';
		return $image;
	}
}

?>
