<?php
class amazonMediaManager
{
	var $_base_url = null;
	
	var $_service = null;

//variable is renamed		
	var $_accesskey_id = null;
	
	var $_associate_tag = null;
	
	var $_locale = null;

// Add secret key	
	var $_secret_id = null;
	
	var $_parameters = array();	
	
	var $_XML_LIST_ELEMENTS = array("Item");

//variable sunbscriptionkey is renamed to accesskey
	function amazonMediaManager($parameters = null, $locale = 'uk', $associateTag = null, $accesskeyId = '1B66SC36ZAZ0WY71QH02', $service = 'AWSECommerceService', $baseUrl = 'http://webservices.amazon.') {
		
		$this->_parameters = $parameters;		
		$this->_locale = $locale;
		$this->_associate_tag = (($associateTag != null)?$associateTag : null);

//variable sunbscriptionkey is renamed to accesskey		
  	$this->_accesskey_id = get_option('amm_devid');
		if ( !$this->_accesskey_id ) update_option('amm_devid', AMM_DEVKEY);
		
// find out what the secret key is	
		$this->_secret_id = get_option('amm_secretid');
		if ( !$this->_secret_id ) update_option('amm_secretid', AMM_SECRET);
					
		$this->_service = $service;
		$this->_base_url = $baseUrl;	
	}	
	
	function doItemSearch() {
		$request = $this->_setUrl($this->_parameters);
		return $this->_sendRequest($request);
		
	}
		
	function &_setUrl() {		
		//Build URL from base URL and other required parameters
			$url = $this->_base_url;
			
			switch ($this->_locale) {				
					
				case 'uk':
					$url .= 'co.uk/onca/xml?';
					break;
				case 'de':
					$url .= 'de/onca/xml?';
					break;
				case 'jp':
					$url .= 'co.jp/onca/xml?';
					break;
				case 'fr':
					$url .= 'fr/onca/xml?';
					break;
				case 'ca':
					$url .= 'ca/onca/xml?';
					break;
				case 'us':
								
				default:
					$url .= 'com/onca/xml?';
					break;
			}

//variable sunbscriptionkey is renamed to accesskey			
			$url .= 'Service='.urlencode($this->_service).'&AWSAccessKeyId='.urlencode($this->_accesskey_id);
			if ($this->_associate_tag != null) {
				$url .= '&AssociateTag='.urlencode($this->_associate_tag);
			}
			
			foreach ($this->_parameters as $param => $val) {
				$url .= '&'.urlencode($param).'='.urlencode($val);
			}	
			
			// if the search terms have spaces in they seem to stop working. + is replaced with %2B to solve this
			// this is just a quick fix - the second item in the array should be to convert '/' to '%2F'. If I do this here
			// though, it converts the entire URL & it will no longer open. It shouldn't be a problem as the keywords are
			// normally unlikely to contain a '/'.	
			$searchstring = array('+');
			$replacestring   = array('%2B');
			$url = str_replace($searchstring, $replacestring, $url);
			
			// Sign the URL that has just been created			
			$signedurl = sign_url($url, $this->_secret_id );
			$url = $signedurl;
			
			// uncomment the line below to view the signed URL & load it to trace problems
			// Echo $url;
									
			return $url;
	}
	
	
	
	function &_sendRequest($url) {
		if (function_exists('curl_init')) {    	
	    	$ch = curl_init();
	    	curl_setopt($ch, CURLOPT_URL, $url);
	    	@curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
	    	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	    	curl_setopt($ch, CURLOPT_TIMEOUT, 20); //max number of seconds to allow for execution		
	    	$data = curl_exec($ch);
	    	
	    	if(curl_errno($ch)) {
			   print curl_error($ch);
			}
			else {
			   curl_close($ch);
			}
	    } 
	    else {
			// curl not available use fopen instead
	    	if ($open_file = fopen($url, "r")) {
	    		$data = "";
	    		while ($r = fread($open_file, 8192)) {
	    	        	$data .= $r;
	    		}
	    	}
	    	else {
	    		return false;
	    	}
		}	
			return $this->_parseXML($data);
	}	
		
	function &_parseXml($data) {
		// create parser
      $parser = xml_parser_create();
      xml_parser_set_option($parser,XML_OPTION_CASE_FOLDING,0);
      xml_parser_set_option($parser,XML_OPTION_SKIP_WHITE,1);
      xml_parse_into_struct($parser,$data,$values,$tags);
      xml_parser_free($parser);

      // we store our path here
      $hash_stack = array();
     
      // this is our target
      $ret = array();      
      foreach ($values as $key => $val) {
       
         switch ($val['type']) {
            case 'open':
               array_push($hash_stack, $val['tag']);
               if (isset($val['attributes']))
                  $ret = &$this->_composeArray($ret, $hash_stack, $val['attributes']);
               else
                  $ret = &$this->_composeArray($ret, $hash_stack);
               break;

            case 'close':
               array_pop($hash_stack);
               break;

            case 'complete':
               array_push($hash_stack, $val['tag']);
               if (isset($val['value'])) {
               	$ret = $this->_composeArray($ret, $hash_stack, $val['value']);               
               }
               array_pop($hash_stack);
               
               
               // handle attributes
               if (isset($val['attributes']))
               {               	  
                  while(list($a_k,$a_v) = each($val['attributes']))
                  {
                     $hash_stack[] = $val['tag']."_attribute_".$a_k."=".$a_v;
                     $ret = &$this->_composeArray($ret, $hash_stack, $a_v);
                     array_pop($hash_stack);
                  }
               }
               break;        }
     }     
     return $ret;		
	}
	
	function &_composeArray($array, $elements, $value=array())  {
     $this->_XML_LIST_ELEMENTS;
     
     // get current element
     $element = array_shift($elements);
     
     // does the current element refer to a list
     if (in_array($element,$this->_XML_LIST_ELEMENTS))
     {
        // more elements?
        if(sizeof($elements) > 0)
        {
           $array[$element][sizeof($array[$element])-1] = &$this->_composeArray($array[$element][sizeof($array[$element])-1], $elements, $value);
        }
        elseif (is_array($value))
        {
           $size = (isset($array[$element]))?  sizeof($array[$element]) : 0;
            $array[$element][$size] = $value;
        }
     }
     else
     {
        // more elements?
        if(sizeof($elements) > 0)
        {
           $array[$element] = $this->_composeArray($array[$element], $elements, $value);           
        }
        else
        {
           $array[$element] = $value;
        }        
     }
       
     return $array;
  }
}


//Function to sign URLs with secret key
//Code taken from: http://www.alssoftware.com/article.php?aid=amzsigning

function sign_url($url, $_secret_id){
  $secret = $_secret_id;  
  
  $host = parse_url($url,PHP_URL_HOST);
  $timestamp = gmstrftime("%Y-%m-%dT%H:%M:%S.000Z");
  $url = $url . "&Timestamp=" . $timestamp;
  // echo $url . "<BR>"; // display overridden url for testing

  $paramstart = strpos($url,"?");
  $workurl = substr($url,$paramstart+1);
  $workurl = str_replace(",","%2C",$workurl);
  $workurl = str_replace(":","%3A",$workurl);
  
  $params = explode("&",$workurl);
  sort($params);

  $signstr = "GET\n" . $host . "\n/onca/xml\n" . implode("&",$params);
  $signstr = base64_encode(hash_hmac('sha256', $signstr, $secret, true));
  $signstr = urlencode($signstr);
  $signedurl = $url . "&Signature=" . $signstr;
  // echo $signedurl . "<BR>";  // display the signed URL for testing
  return $signedurl;
}
?>